package com.zksy.controller.info;

import com.zksy.info.domain.EAdminLicenseInfo;
import com.zksy.info.domain.EDepartmentEmployeeStats;
import com.zksy.info.service.EAdminLicenseInfoService;
import com.zksy.info.service.EDepartmentEmployeeStatsService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 部门员工统计控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/edepartmentEmployeeStats")
@Api(tags = "部门员工统计信息",description = "部门员工统计信息desc")
public class EDepartmentEmployeeStatsController {
    @Autowired
    private EDepartmentEmployeeStatsService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "部门员工统计信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String departmentName){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, departmentName));
    }
    @GetMapping("/getEDepartmentEmployeeStatsList")
    @ApiOperation(value = "部门员工统计信息查询")
    public AjaxResult getEDepartmentEmployeeStatsList(String departmentName){
        return AjaxResult.success(service.getEDepartmentEmployeeStatsList(departmentName));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询部门员工统计信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "部门员工统计信息保存")
    public AjaxResult save(@RequestBody EDepartmentEmployeeStats entity) {
        return service.save(entity) ? AjaxResult.success(entity): AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "部门员工统计信息修改")
    public AjaxResult update(@RequestBody EDepartmentEmployeeStats entity) {
        entity.setUpdateTime(LocalDateTime.now());
        return service.updateById(entity) ? AjaxResult.success(entity): AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "部门员工统计信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EDepartmentEmployeeStats.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String departmentName) {
        ExcelExportUtil.exportExcel(response,service.getEDepartmentEmployeeStatsList(departmentName), EDepartmentEmployeeStats.class, "部门员工统计信息","部门员工统计信息");
    }

}
